'---------------------------------------------------------------------------------------------------
' This program was written with BLIde (www.blide.org)
' Application: Decompiler
' Author: Kippykip
' License: do whatever you fucken want
'---------------------------------------------------------------------------------------------------
Strict
Framework brl.FileSystem
Import BRL.StandardIO
Import BRL.System
Import BRL.Retro

Include "algorithm.bmx"	'So we can do MD5 hashes
Global StartTime:Float = Float(MilliSecs())     'Get time at start, so we know how long it took to complete
Print "Magic Ball 2 - Resolution Changer - http://kippykip.com"

'Load our special file, which tells us where offsets are depending on the MD5
If(FileType("hashes.txt") <> 1) 
	Crash("Couldn't find 'hashes.txt' file.") 
EndIf
Print "Loading 'hashes.txt'..."
Global TXT_Hashes:TStream = ReadStream("hashes.txt") 

'This file is Magic Ball 2's settings file.
'It contains the resolution index (Since we're modifying the lowest one, we need to change this to index 0)
'It also contains a Windowed mode parameter.
'The rest of the game options work fine in the menus in-game.
If(FileType("params.txt") <> 1) 
	Crash("Couldn't find 'params.txt' file. You may need to run the game at least once.") 
EndIf
Print "Loading 'params.txt'..."
Global TXT_Params:TBank = LoadBank("params.txt") 

Global STR_EXEFN:String
Global STR_MD5:String
Global STR_Offset0:Int
Global STR_Offset1:Int
Global STR_Offset2:Int
Global STR_Offset3:Int
Global STR_Offset4:Int
Global STR_Offset5:Int
Global STR_Offset6:Int
Global STR_Offset7:Int
Global STR_Offset8:Int
Global STR_Offset9:Int
Global STR_Offset10:Int
Global STR_Offset11:Int
Global STR_Type:String
Global Bank_EXE:TBank
Global Bank_BackupEXE:TBank

'Our new values
Global New_Width:Int = DesktopWidth() 
Global New_Height:Int = DesktopHeight() 
Global New_Window:Int = 0

'If no argument
If(AppArgs.Length <= 1) 
	Print "Note: No commandline specified! Using Desktop resolution (" + New_Width:Int + "x" + New_Height:Int + ") as fullscreen mode."
	Print "Command lines are:"
	Print "ResolutionChanger.exe <Width> <Height> <Windowed>"
	Print "Examples: ResolutionChanger.exe 1280 720 0"
	Print Chr:String(10)   'NewLine
ElseIf(AppArgs.Length = 2)  'If 1 argument
	Crash("Missing 'Height' argument") 
Else
	If(AppArgs.Length > 3) 
		If(AppArgs[3] = "0" Or Lower:String(AppArgs[3] ) = "false") 
			New_Window:Int = 0
		ElseIf(AppArgs[3] = "1" Or Lower:String(AppArgs[3] ) = "true") 
			New_Window:Int = 1
		Else 'If there's only 2 arguments?
			Print "Warning: Unknown value for <Windowed> argument, presuming 'Fullscreen' mode. (0)"
		EndIf
	Else
		Print "Warning: Missing 'Windowed' argument, presuming 'Fullscreen' mode. (0)"
	EndIf
	New_Width:Int = Int(AppArgs[1] ) 
	New_Height:Int = Int(AppArgs[2] ) 
	If(New_Window:Int = 0) 
		Print "Using resolution: " + New_Width:Int + "x" + New_Height:Int + " as 'Fullscreen' mode."
	Else
		Print "Using resolution: " + New_Width:Int + "x" + New_Height:Int + " as 'Windowed' mode."
	EndIf
EndIf


'Our arrays for hashes.txt for game versions etc
Global Array_Hashes:String[] = Upper(ReadLine(TXT_Hashes)).Split("|") 
Global Array_Offsets0:String[] = ReadLine(TXT_Hashes).Split("|") 
Global Array_Offsets1:String[] = ReadLine(TXT_Hashes).Split("|") 
Global Array_Offsets2:String[] = ReadLine(TXT_Hashes).Split("|") 
Global Array_Offsets3:String[] = ReadLine(TXT_Hashes).Split("|") 
Global Array_Offsets4:String[] = ReadLine(TXT_Hashes).Split("|") 
Global Array_Offsets5:String[] = ReadLine(TXT_Hashes).Split("|") 
Global Array_Offsets6:String[] = ReadLine(TXT_Hashes).Split("|") 
Global Array_Offsets7:String[] = ReadLine(TXT_Hashes).Split("|") 
Global Array_Offsets8:String[] = ReadLine(TXT_Hashes).Split("|") 
Global Array_Offsets9:String[] = ReadLine(TXT_Hashes).Split("|") 
Global Array_Offsets10:String[] = ReadLine(TXT_Hashes).Split("|") 
Global Array_Offsets11:String[] = ReadLine(TXT_Hashes).Split("|") 
Global Array_EXEFN:String[] = ReadLine(TXT_Hashes).Split("|") 
Global Array_Type:String[] = ReadLine(TXT_Hashes).Split("|") 

'Just a check to make sure there's no mismatch in our arrays
If(Array_Offsets0.Length <> Array_Hashes.Length Or Array_Offsets1.Length <> Array_Hashes.Length Or Array_Offsets2.Length <> Array_Hashes.Length Or Array_Offsets3.Length <> Array_Hashes.Length Or Array_Offsets4.Length <> Array_Hashes.Length Or Array_Offsets5.Length <> Array_Hashes.Length Or Array_Offsets6.Length <> Array_Hashes.Length Or Array_Offsets7.Length <> Array_Hashes.Length Or Array_Offsets8.Length <> Array_Hashes.Length Or Array_Offsets9.Length <> Array_Hashes.Length Or Array_Offsets10.Length <> Array_Hashes.Length Or Array_Offsets11.Length <> Array_Hashes.Length Or Array_EXEFN.Length <> Array_Hashes.Length Or Array_Type.Length <> Array_Hashes.Length) 
	Crash("Array mismatch in 'hashes.txt'") 
EndIf

'Find out which filename you have in the folder, incase they're different
For Local TMP_Count = 0 To Array_EXEFN.Length - 1
	If(FileType(Array_EXEFN[TMP_Count] ) = 1) 
		STR_EXEFN:String = Array_EXEFN[TMP_Count] 
	EndIf
Next
If(STR_EXEFN:String.Length <= 0)  'Nothing was found?
	Crash("Couldn't find a relevant Magic Ball EXE file.") 
Else
	Print "Found a matching EXE filename. (" + STR_EXEFN:String + ")"
EndIf

'Lets start loading the EXE file.
'NOTE: We create a backup EXE file, and since we're comparing the MD5 to our personal hashes.txt list, it would be wise to load the MD5 though the original right? :^)
Bank_EXE:TBank = LoadBank(STR_EXEFN:String) 
If(FileType(STR_EXEFN:String + ".bak") = 1)   'Does the backup already exist?
	Bank_BackupEXE:TBank = LoadBank(STR_EXEFN:String + ".bak")  'Then load it and use the MD5 from the backup
	STR_MD5:String = MD5_Bank:String(Bank_BackupEXE:TBank) 
	Print "Backup file already exists, using backup MD5..."
Else										'No?
	STR_MD5:String = MD5_Bank:String(Bank_EXE:TBank)  'Then just use the MD5 straight from the file
	SaveBank(Bank_EXE:TBank, STR_EXEFN:String + ".bak")    'Create a backup for later
	Print "No backup EXE, creating '" + STR_EXEFN:String + ".bak'."
EndIf

'Compare the MD5s to our list and find out whats the correct offset for where the resolutions are stored
For Local TMP_Count = 0 To Array_Hashes.Length - 1
	If(Array_Hashes[TMP_Count] = STR_MD5:String) 
		STR_Offset0:Int = Int(Array_Offsets0[TMP_Count] ) 
		STR_Offset1:Int = Int(Array_Offsets1[TMP_Count] ) 
		STR_Offset2:Int = Int(Array_Offsets2[TMP_Count] ) 
		STR_Offset3:Int = Int(Array_Offsets3[TMP_Count] ) 
		STR_Offset4:Int = Int(Array_Offsets4[TMP_Count] ) 
		STR_Offset5:Int = Int(Array_Offsets5[TMP_Count] ) 
		STR_Offset6:Int = Int(Array_Offsets6[TMP_Count] ) 
		STR_Offset7:Int = Int(Array_Offsets7[TMP_Count] ) 
		STR_Offset8:Int = Int(Array_Offsets8[TMP_Count] ) 
		STR_Offset9:Int = Int(Array_Offsets9[TMP_Count] ) 
		STR_Offset10:Int = Int(Array_Offsets10[TMP_Count] ) 
		STR_Offset11:Int = Int(Array_Offsets11[TMP_Count] ) 
		STR_Type:String = Array_Type[TMP_Count] 
	EndIf
Next
'If the magic ball 2 MD5 in your folder doesn't match any listed in our hashes.txt
If(STR_Type:String.Length <= 0) 
	Crash("Magic Ball EXE mismatches all known MD5 hashes. Please email gm_kip@hotmail.com and submit your MB2 sample if possible.") 
Else
	Print "Found a matching MD5. (" + STR_MD5:String + ")"
EndIf
Print "Game = " + STR_Type:String
Print "Current EXE resolution for index 0 is: " + PeekInt(Bank_EXE:TBank, STR_Offset0:Int) + "x" + PeekInt(Bank_EXE:TBank, STR_Offset1:Int) 
Print "Current EXE resolution for index 1 is: " + PeekInt(Bank_EXE:TBank, STR_Offset2:Int) + "x" + PeekInt(Bank_EXE:TBank, STR_Offset3:Int) 
Print "Current EXE resolution for index 2 is: " + PeekInt(Bank_EXE:TBank, STR_Offset4:Int) + "x" + PeekInt(Bank_EXE:TBank, STR_Offset5:Int) 
Print "Current EXE resolution for index 3 is: " + PeekInt(Bank_EXE:TBank, STR_Offset6:Int) + "x" + PeekInt(Bank_EXE:TBank, STR_Offset7:Int) 
Print "Current EXE resolution for index 4 is: " + PeekInt(Bank_EXE:TBank, STR_Offset8:Int) + "x" + PeekInt(Bank_EXE:TBank, STR_Offset9:Int) 
Print "Current EXE resolution for index 5 is: " + PeekInt(Bank_EXE:TBank, STR_Offset10:Int) + "x" + PeekInt(Bank_EXE:TBank, STR_Offset11:Int) 

PokeInt(Bank_EXE:TBank, STR_Offset0:Int, New_Width:Int)               'Width (Was 640)
PokeInt(Bank_EXE:TBank, STR_Offset1:Int, New_Height:Int)            'Height (Was 480)

'MagicBall seems to have issues if the next resolution is lower than the one before, lets fix this by making the next resolutions insanely high
PokeInt(Bank_EXE:TBank, STR_Offset2:Int, 12222)               'Width (Was 800)
PokeInt(Bank_EXE:TBank, STR_Offset3:Int, 12222)                  'Height (Was 600)
PokeInt(Bank_EXE:TBank, STR_Offset4:Int, 13333)                  'Width (Was 1024)
PokeInt(Bank_EXE:TBank, STR_Offset5:Int, 13333)                   'Height (Was 768)
PokeInt(Bank_EXE:TBank, STR_Offset6:Int, 14444)                    'Width (Was 1152)
PokeInt(Bank_EXE:TBank, STR_Offset7:Int, 14444)                      'Height (Was 864)
'These ones for whatever reason, are in a completely different spot
PokeInt(Bank_EXE:TBank, STR_Offset8:Int, 15555)                       'Width (Was 1280)
PokeInt(Bank_EXE:TBank, STR_Offset9:Int, 15555)                          'Height (Was 960)
PokeInt(Bank_EXE:TBank, STR_Offset10:Int, 16666)                     'Width (Was 1600)
PokeInt(Bank_EXE:TBank, STR_Offset11:Int, 16666)                          'Height (Was 1200)

SaveBank(Bank_EXE:TBank, STR_EXEFN:String) 
Print "Saving '" + STR_EXEFN:String + "' changes."

Function Crash(TMP_ErrString:String = "Unknown Error") 
	Print("Error: " + TMP_ErrString) 
	Print "Closing console in 5 Seconds..."
	Delay 5000
	End
End Function

'This handy function will constantly search the bank for a string
Function SearchBank:Int(TMP_Bank:TBank, TMP_SearchStr:String) 
	For Local XX = 0 To (BankSize(TMP_Bank) - 1 - TMP_SearchStr.Length) 
		Local TMP_CurrentString:String
		For Local YY = 0 To TMP_SearchStr:String.Length - 1
			TMP_CurrentString:String = TMP_CurrentString:String + Chr:String(PeekByte(TMP_Bank:TBank, XX + YY)) 
		Next
		If(Lower:String(TMP_CurrentString:String) = Lower:String(TMP_SearchStr:String)) 
			Return XX
		EndIf
	Next
End Function

'48 = 0 ASCII character
'49 = 1 ASCII character
PokeByte(TXT_Params:TBank, SearchBank:Int(TXT_Params:TBank, "resolution: ") + Len("resolution: "), 48) 
Print "Set resolution index in 'params.txt' to 0."
PokeByte(TXT_Params:TBank, SearchBank:Int(TXT_Params:TBank, "window: ") + Len("window: "), 48 + New_Window:Int) 
Print "Set 'Windowed Mode' in 'params.txt' to " + New_Window:Int + "."
SaveBank(TXT_Params:TBank, "params.txt") 
Print "Saving 'params.txt' changes."
Print Chr:String(10)  'NewLine
Print "Done patching! " + (Float(MilliSecs()) - StartTime:Float) / 1000 + "s"
Print "Closing console in 5 Seconds..."
Delay 5000